#include <string.h>
#include "ErrorDescription.h"

ErrorDescription::ErrorDescription () : _error_source(0), _error_message(0), _error_code(0)
{
    clearError();
}

void ErrorDescription::clearError ()
{
    // clear error code
    _error_code = 0;
    
    // clear source
    if (_error_source) {
        delete[] _error_source;
        _error_source = 0;
    }

    // clear message
    if (_error_message) {
        delete[] _error_message;
        _error_message = 0;
    }
}

void ErrorDescription::setError (int code, const char * pSource)
{
    setError(code, pSource, (char*)0);
}

void ErrorDescription::setError (int code, const char * pSource,
        const char * pMessage)
{
    clearError();
    _error_code = code;
    
    if (pSource) {
        _error_source = new char[strlen(pSource) + 1];
        strcpy(_error_source, pSource);
    }
    
    if (pMessage) {
        _error_message = new char[strlen(pMessage) + 1];
        strcpy(_error_message, pMessage);
    }
}

int ErrorDescription::getErrorCode()
{
    return _error_code;
}

const char* ErrorDescription::getErrorSource()
{
    return _error_source;
}
const char* ErrorDescription::getErrorMessage()
{
    return _error_message;
}

